      subroutine convert_from_state(u, v, phi, x, n, m, nt, k)

!     Convert to shallow-water equation variables u,v,phi from 
!     the control variable x.  The values from x are stored in 
!     u(:,:,1), v(:,:,1), phi(:,:,1).  The data in x is assumed to
!     have the values of u, the values of v, and the values of phi,
!     in that order.
      implicit none

! size parameters
      integer, intent(in) :: n, m, nt, k

! control variable
      double precision, intent(in) :: x(*)

! state variables
      double precision, dimension(n,m,nt), intent(inout) :: u, v, phi

! local variables
      integer :: i, j, jidc1, jidc2, jidc3

      do j = 2, m-1
          do i = 2, n-1
              jidc1 = i - 1 + (j - 2)*(n - 2)
              jidc2 = jidc1 + (n-2)*(m-2)
              jidc3 = jidc2 + (n-2)*(m-2)

              u(i, j, k) = x(jidc1)
              v(i, j, k) = x(jidc2)
              phi(i, j, k) = x(jidc3)
          enddo
      enddo

      return
      end
